function [schedule,arrive]=countschedule(numtank,demand,time)
    tt=time(1);
    tr=time(2);
    n=numtank;
    e=-%inf;
    A0=[e,e;tt,e];
    A1=[e,tr;e,e];
    B0=[0;e];
    C=[e,0];
    
    //pendefinisian A0,A1,B0,C
    A0=[e,e;tt,e];
    A1=[e,tr;e,e];
    B0=[0;e];
    C=[e,0];
    //menghitung A0 star
    A0star=maxplusstar(A0);
    
    //menentukan matriks A dan B
    A=maxplusotimes(A0star,A1);
    B=maxplusotimes(A0star,B0);
    
    nd=length(demand);
    Yd=demand;
    //mendefinisikan alphamaks dan sisa yang menggunakan alphamaks
    alphamaks=ceil(nd/n);
    sisa=nd-(alphamaks-1)*n;

    //mendefinisikan H ukuran alphax1
    Htemp=maxpluszeros(1,alphamaks);
    temp=maxpluseye(2,2);
    for i=alphamaks:-1:1
        temp1=maxplusotimes(C,temp);
        temp1=maxplusotimes(temp1,B);
        Htemp(i)=temp1;
        temp=maxplusotimes(A,temp);
    end
    //tempat untuk jadwal keberangkatan
    jadwal=zeros(nd,1);
    
    //mendefinisikan H ukuran alphaxalpha dengan alpha yang maksimal
    H=maxpluszeros(alphamaks,alphamaks);
    for i=1:alphamaks
        H(i,1:alphamaks-i+1)=Htemp(i:alphamaks);
        Htemp(i)=e;
    end
    
    //menentukan jadwal
    for i=1:sisa
        btemp=Yd(i:n:(alphamaks)*n);
        l=length(btemp);
        btemptemp=btemp;
        for j=1:l
            btemp(j)=btemptemp(l-j+1);
        end
        jadwal1=maxpluslinsol(H,btemp);
        jadwal(i:n:(alphamaks)*n)=jadwal1;
    end
    //menentukan jadwal untuk alpha tidak maksimal
    if sisa<n then
        Htemp=H(1,2:alphamaks);
        H=maxpluszeros(alphamaks-1,alphamaks-1);
        //menentukan H
        for i=1:alphamaks-1
            H(i,1:alphamaks-i)=Htemp(i:alphamaks-1);
            Htemp(i)=e;
        end
        //jadwal untuk alpha tidak maksimal
        for i=sisa+1:n
            btemp=Yd(i:n:(alphamaks-1)*n);
            l=length(btemp);
            btemptemp=btemp;
            for j=1:l
                btemp(j)=btemptemp(l-j+1);
            end
            jadwal1=maxpluslinsol(H,btemp);
            jadwal(i:n:(alphamaks-1)*n)=jadwal1;
        end
    end
    
    //jadwal tiba
    jadwaltiba=tt*ones(nd,1)+jadwal;
    schedule=jadwal;
    arrive=jadwaltiba;
endfunction
