function tran = firingorder(forward,backward, ...
  initmark,mark)
  // fungsi ini bertujuan untuk mencari urutan pemfirean
  // sehingga diperoleh node yang mengcover keadaan

  // inisialisasi
  tran = [];

  // apakah root mengcover mark ?
  if iscovers(initmark,mark)
    return;
  end
  // inisialisasi proses
  [initmark,tran] = findchild(forward,backward, ...
    initmark,tran);
  idcover = vectorfind(bool2s( ...
    ones(1,size(initmark,2)).*.mark <= initmark), ...
    ones(length(mark),1),'c');

  // perulangan (inti)
  while idcover == []
    [initmark,tran] = findchild(forward,backward, ...
      initmark,tran);
    idcover = vectorfind(bool2s( ...
      ones(1,size(initmark,2)).*.mark <= initmark), ...
      ones(length(mark),1),'c');
  end

  // memfilter urutan transisi yang memenuhi
  tran = tran(:,idcover);
endfunction
