function generalscheduling

    toolbox_dir = "SCI/contrib/";
    toolbox_dir2=dir("SCI/contrib");
    name=toolbox_dir2.name;
    dates=toolbox_dir2.date;
    [datesa,datesb]=gsort(dates);
    name=name(datesb);
    sizename=size(name,1);
    hit=0;
    for i=1:sizename
        if length(name(i))>=8 then
            sementara=strsplit(name(i),7);
            sementara=sementara(1);
            if sementara=='MAXPLUS' then
                hit=i;
                break;
            end
        end    
    end
    if hit~=0 then
        toolbox_dir=toolbox_dir+name(hit)+'/modules/';
    end
    //disp(toolbox_dir);
    //input tanggal permintaan melalui file xls
    jwb = uigetfile('*.xls',toolbox_dir,Title='Choose xls for graph as a route and the number of public vehicle ');
    
//jwb = uigetfile('*.xls',Title='Choose xls for date of demand, capacity and number of unit demand');
    if jwb == ''
      disp('You exit from this process');
      return;
    end
    
    //membaca file
    Sheets = readxls(jwb);
    
    //menentukan nilai dari tanggal permintaan
    s1=Sheets(1);
    A=s1.value;
    s1=Sheets(2);
    N=s1.value;
    s1=Sheets(3);
    H=s1.text;
    
    n=size(A,1);
    for i=1:n
        for j=1:n
            if isnan(A(i,j)) then
                A(i,j)=-%inf;
            end
        end
    end



//A=round(60*rand(5,5));
//N=[1,2,1,2,1;2,1,2,1,2;1,2,1,2,1;2,1,2,1,2;1,2,1,2,1];
//H=['halte 1';'halte 2';'halte 3';'halte 4';'halte 5'];
//
//A=[3,6;4,5];
//N=[1,0;2,1];
//H=['halte 1';'halte 2'];

m=max(max(N));



e=-%inf;
n=size(A,1);
hit=0;
cari=find(A~=e);
Data=zeros(length(cari),4);
Halte=[];
for i=1:n
    for j=1:n
        if A(j,i)~=e then
            hit=hit+1;
            //time
            Data(hit,1)=A(j,i);
            //early
            Data(hit,2)=i;
            //destination
            Data(hit,3)=j;
            //number vehicle
            Data(hit,4)=N(j,i);
            //Halte awal dan tujuan
            Halte=[Halte;H(i)+' to '+H(j)]
        end
    end
end
polyA=zeros(hit,hit,m+1);
for i=1:m+1;
    if i==2 then
        polyA(:,:,i)=maxpluszeros(hit,hit);
    else
        polyA(:,:,i)=maxpluszeros(hit,hit);
    end
end

for i=1:hit
    tuj=Data(i,2);
    cari=find(Data(:,3)==tuj);
    polyA(i,cari,Data(i,4)+1)=Data(cari,1);
end

clear Data;

A0star=maxplusstar(polyA(:,:,1));
cari=find(A0star==%inf);
if length(cari)~=0 then
    error('A0 have cycle');
    return;
end

for i=1:m
    polyA(:,:,i+1)=maxplusotimes(A0star,polyA(:,:,i+1));    
end

Aakhir=maxpluszeros(m*hit,m*hit);
if m>1 then
    Aakhir(1:(m-1)*hit,hit+1:m*hit)=maxpluseye((m-1)*hit,(m-1)*hit);
end


for i=1:m
    Aakhir((i-1)*hit+1:i*hit,1:hit)=polyA(:,:,i+1);
end

clear polyA;

//lam=period
//vx=early departure


count=size(Aakhir,1);
i=count;
while i>0
    cari=find(Aakhir(i,:)~=-%inf);
    if length(cari)==0 then
        Aakhir(i,:)=[];
        Aakhir(:,i)=[];
    end
    i=i-1;
end


[lam,vx,sigma,q]=maxplusmaxalgolgeneral(Aakhir,zeros(size(Aakhir,1),1));
vx=vx(1:hit);
lam=lam(1:hit);
vawal=maxplusotimes(vx,-min(vx));

[eigval,dp,criticalcircuit] = maxplusccir(A)
disp('Critical Circuit:')
disp(criticalcircuit);

jwb1 = x_mdialog('Maximum of departure period',['Period of departure(minute)'],string(max(lam)));
          if jwb1==[] then
              return;
          end
       
jwb2 = x_mdialog('Enter time of earliest initial departure',['Hour';'minute'],['6';'0']);
          if jwb2==[] then
              return;
          end 
          hour=evstr(jwb2(1));
          minute=evstr(jwb2(2));
jwb2 = x_mdialog('Enter number of departure',['number of departure: '],['10']);
          if jwb2==[] then
              return;
          end 
          numdep=evstr(jwb2(1));
          
integ=60*hour+minute;

//Lam=maxplusotimes(lam,maxpluseye(hit,hit));

//setiap putaran 8
numdep1=numdep;
banyakput=ceil(numdep1/8);

for put=1:banyakput
    if  put==banyakput then
        numdep=modulo(numdep1-1,8)+1;
    else
        numdep=8;
    end
table1=maxpluszeros(hit,numdep);
table1(:,1)=maxplusotimes(integ,vawal);


disp(size(lam));
disp(size(table1(:,1)));

for i=2:numdep
    table1(:,i)=lam+table1(:,i-1);
end

//clear lam;
//clear vx;
//clear vawal;

table2=string(zeros(hit,numdep));

for i=1:hit
    for j=1:numdep
        jam=0;
        waktu=table1(i,j);
        while waktu>=60
            jam=jam+1;
            waktu=waktu-60;
        end
        jam=modulo(jam,24);
        menit=floor(waktu);
        detik=round(60*(waktu-menit));
        if jam<10 then
            jam='0'+string(jam);
        else
            jam=string(jam);    
        end
        
        if menit<10 then
            menit='0'+string(menit);
        else
            menit=string(menit);    
        end
        if detik<10 then
            detik='0'+string(detik);
        else
            detik=string(detik);    
        end
        table2(i,j)=[jam+':'+menit+':'+detik];
    end
end
clear table1;

number=string([1:hit]);
tit=['No','Route'];
for i=1:numdep
    tit(i+2)='Departure '+string((put-1)*8+i);
end

data=[tit;[number',Halte,table2]];
    
    
    //menampilkan
    f = gcf();
    f.position=[10,10,1100,400] 
    clf
    as = f.axes_size;  // [width height]
    ut=3;
    ut = uicontrol("style","table",..
                   "string",data,..
                   "position",[5 as(2)-400 800 387],.. // => @top left corner of figure
                   "tooltipstring","Data from majors towns")
    delete(ut);
    ut = uicontrol("style","table",..
                   "string",data,..
                   "position",[5 as(2)-400 1050 387],.. // => @top left corner of figure
                   "tooltipstring","Data from majors towns")
    if put~=banyakput then              
    jwb2=messagebox([''; ...
            'Do you want to see the next schedule?'],"modal", "info", ["Yes" "No/exit"]);
            // keluar dari perulangan
                if jwb2==2 then
                    return;
                end
                
    vawal=lam+8*lam+vawal;   
    end      

end
endfunction
