function [Z] = minmaxplussysser(A,B,z0,q) 
Z=[];

[%nargout,%nargin] = argn(0);
mode(0);

ieee(1);

if isempty(A) | isempty(B) | isempty(z0) | isempty(q) then
  error("maxplussys: empty input value");
end;


if size(z0,2)~=1 then
  error("maxplussys: initial vector must be a column vector!");
end;

Z = zeros(length(z0),q+1);
Z(:,1) = z0;
for i = 1:q
  Z(:,i+1) = minmaxplussys(A,B,Z(:,i));
end;

endfunction
