function X = minplusoplus(A,B) 

// X = maxplusoplus_rev(A,B), Maxplus algebra addition with appropriate size.
// X_{i,j} = max(A,B)_{i,j}
//
// See also: 
// maxpluspwr, maxplusscg, maxcircuit, maxalgol, maxalgolpa, maxalgolepa, iseigvec


// Output variables initialisation (not found in input variables)
X = [];

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

if isequal(size(A),size(B)) == %f
   error("minplusoplus: matrices must be the same size");
end

X = min(A,B);


endfunction
