function supplychainscheduleex
    jwb=['5';'2'];
    jwb = x_mdialog('enter input ',... 
          ['time for arrival tanker from TBBM (source) to other TBBM (destination)';'time for arrival tanker from TBBM (destination) to Tuban (source)'],jwb);
          if jwb==[] then
              return;
          end
    tt=evstr(jwb(1));
    tr=evstr(jwb(2));
    e=-%inf;
    //pendefinisian A0,A1,B0,C
    A0=[e,e;tt,e];
    A1=[e,tr;e,e];
    B0=[0;e];
    C=[e,0];
    //menghitung A0 star
    A0star=maxplusstar(A0);
    
    //menentukan matriks A dan B
    A=maxplusotimes(A0star,A1);
    B=maxplusotimes(A0star,B0);


    //input tanggal permintaan melalui file xls
    
    toolbox_dir = "SCI/contrib/";
    toolbox_dir2=dir("SCI/contrib");
    name=toolbox_dir2.name;
    dates=toolbox_dir2.date;
    [datesa,datesb]=gsort(dates);
    name=name(datesb);
    sizename=size(name,1);
    hit=0;
    for i=1:sizename
        if length(name(i))>=8 then
            sementara=strsplit(name(i),7);
            sementara=sementara(1);
            if sementara=='MAXPLUS' then
                hit=i;
                break;
            end
        end    
    end
    if hit~=0 then
        toolbox_dir=toolbox_dir+name(hit)+'/modules/Demand/';
    end
    //disp(toolbox_dir);
    //input tanggal permintaan melalui file xls
    jwb = uigetfile('*.xls',toolbox_dir,Title='Choose xls for date of demand, capacity and number of unit demand');
    
    
    
    //jwb = uigetfile('*.xls',Title='Choose xls for date of demand, capacity and number of unit demand');
    if jwb == ''
      disp('You exit from this process');
      return;
    end
    
    //membaca file
    Sheets = readxls(jwb);
    
    //menentukan nilai dari tanggal permintaan
    s1=Sheets(1);
    jwb=s1.value;
    nd=size(jwb,1);
    
    cc=[];
    for hh=1:nd
        if isnan(jwb(hh,1)) then
            cc=[cc,hh];
        end
    end
    jwb(cc,:)=[];
    nd=size(jwb,1);
    
    
    //String untuk kebrangkatan ke-...
    Ks=1:nd;
    Ks=Ks';
    KS=''+string(Ks)+' th '+'demand: ';
    
    //merubah bentuk tanggal ke string
    jwb1=[];
    for i=1:nd
        jwb1=[jwb1;date2str(jwb(i,1),jwb(i,2),jwb(i,3))];
    end
    start=min(jwb(i,3))-1;
    jwb=jwb1;
    
    //menampilkan data dari tanggal permintaan
    jwb = x_mdialog('date of demand ',... 
          KS,jwb);
          if jwb==[] then
              return;
          end
          
    //merubah string tanggal ke tanggal
    jwb1=zeros(nd,3);
    for i=1:nd
        jwb1(i,:)=str2date(jwb(i));
    end
    
    //merubah tanggal ke integer
    Yd=zeros(nd,1);
    for i=1:nd
        Yd(i)=date2int(jwb1(i,1),jwb1(i,2),jwb1(i,3),start);
    end
    t=Yd;
    
    
    
    
    
    
    
    
    
    
    
    
    
    //menentukan banyaknya permintaan pertanggal
    s1=Sheets(2);
    jwb=s1.value;
    nd=size(jwb,1);
    
    cc=[];
    for hh=1:nd
        if isnan(jwb(hh,1)) then
            cc=[cc,hh];
        end
    end
    jwb(cc)=[];
    nd=size(jwb,1);
    
    
    
    //String untuk kebrangkatan ke-...
    Ks=1:nd;
    Ks=Ks';
    KS=''+string(Ks)+' th '+'demand: ';
    
    //merubah bentuk number of unit ke string
    
    jwb=string(jwb);
    
    //menampilkan data dari banyaknya unit yang diperlukan
    jwb = x_mdialog('number unit of demand ',... 
          KS,jwb);
          if jwb==[] then
              return;
          end
    pt=evstr(jwb);
    num_per=length(pt);
    
    
    
    
    
    
    
    
    //menentukan kapasitas tanker
    s1=Sheets(3);
    jwb=s1.value;
    nd=size(jwb,1);
    
    cc=[];
    for hh=1:nd
        if isnan(jwb(hh,1)) then
            cc=[cc,hh];
        end
    end
    jwb(cc)=[];
    nd=size(jwb,1);
    
    
    
    //String untuk kapal tanker ke-...
    Ks=1:nd;
    Ks=Ks';
    KS=''+string(Ks)+' th '+'tanker: ';
    
    //merubah bentuk number of unit ke string
    
    jwb=string(jwb);
    
    //menampilkan kapasitas tanker
    jwb = x_mdialog('Capacity of tanker (unit)',... 
          KS,jwb);
          if jwb==[] then
              return;
          end
    capacity=evstr(jwb);
    num_ken=length(capacity);
    k=capacity;
    ptawal=pt;
    //mengurutkan tanggal permintaan
    typed=[1:num_per];
    for i=1:num_per-1
        for j=i+1:num_per
            if t(i)>t(j) then
                t([i,j])=t([j,i]);
                pt([i,j])=pt([j,i]);
                typed([i,j])=typed([j,i]);
            end
        end
    end
    
    
    
    //determine schedule
    //semua kemungkinan
    
    if min(capacity)>=max(pt) then
        x=[1:num_ken];
    else
        x=perms([1:num_ken]);
        lx=size(x,1);
        hitt=1;
        while hitt<lx
            a=hitt+1;
            while a<=lx
                if capacity(x(hitt,:))==capacity(x(a,:)) then
                    x(a,:)=[];
                    lx=lx-1;
                else
                    a=a+1;
                end
            end
            hitt=hitt+1;
        end
    end
    num_mungkin=size(x,1);
    //mencoba setiap kemungkinan
    for i=1:num_mungkin
        ttemp=[];
        typedtemp=[];
        pttemp=[];
        hittgl=0;
        //menentukan tanggal permintaan setiap kemungkinan
        for j=1:num_per
            sisat=pt(j);
            sss=k(x(i,(modulo(hittgl,num_ken))+1));
            while sss<sisat
                hittgl=hittgl+1;
                pttemp(hittgl)=sss;
                ttemp(hittgl)=t(j);
                typedtemp(hittgl)=typed(j);
                sisat=sisat-sss;
                sss=k(x(i,(modulo(hittgl,num_ken))+1));
            end
            hittgl=hittgl+1;
            pttemp(hittgl)=sisat;
            ttemp(hittgl)=t(j);
            typedtemp(hittgl)=typed(j);
        end
        //jadwal dari permintaan yang terbentuk
        [jadwaltemp,kedatangantemp]=countschedule(num_ken,ttemp,[tt,tr]);
        sp=ttemp-kedatangantemp;
        //hitung syarat pilih
        totalsp=sum(sp);
        cari=find(sp==0);
        numontime=length(cari);
        maxcep=max(sp);
        
        //pilih terbaik
//        if i==1 | (totalsp<=totalsptemp2 & numontime>=numontimetemp2 & maxcep<=maxceptemp2 & hittgl<hittgltemp2) then
//            pttemp2=pttemp;
//            ttemp2=ttemp;
//            typedtemp2=typedtemp;
//            hittgltemp2=hittgl;
//            totalsptemp2=totalsp;
//            numontimetemp2=numontime;
//            maxceptemp2=maxcep;
//            jadwaltemp2=jadwaltemp;
//            kedatangantemp2=kedatangantemp;
//            kendaraan=x(i,:);
//            kap=k(kendaraan);
//        end
          //rasio 2
          ratio=2.5;
          if i==1  | (ratio*(hittgltemp2-hittgl)+(totalsptemp2-totalsp))>0 then
            pttemp2=pttemp;
            ttemp2=ttemp;
            typedtemp2=typedtemp;
            hittgltemp2=hittgl;
            totalsptemp2=totalsp;
            numontimetemp2=numontime;
            maxceptemp2=maxcep;
            jadwaltemp2=jadwaltemp;
            kedatangantemp2=kedatangantemp;
            kendaraan=x(i,:);
            kap=k(kendaraan);    
            sptemp2=sp;         
         elseif ((ratio*(hittgltemp2-hittgl)+(totalsptemp2-totalsp))==0 & numontime>numontimetemp2 & maxcep<maxceptemp2) then
            pttemp2=pttemp;
            ttemp2=ttemp;
            typedtemp2=typedtemp;
            hittgltemp2=hittgl;
            totalsptemp2=totalsp;
            numontimetemp2=numontime;
            maxceptemp2=maxcep;
            jadwaltemp2=jadwaltemp;
            kedatangantemp2=kedatangantemp;
            kendaraan=x(i,:);
            kap=k(kendaraan);
            sptemp2=sp;
         end
    end
    
    
    //tipe, kapasitas, dan yang diangkut dan nd
    nd=hittgltemp2;
    types=zeros(nd,1);
    capacity=zeros(nd,1);
    
    for i=1:nd
        types(i)=kendaraan(modulo(i-1,num_ken)+1);
        capacity(i)=kap(modulo(i-1,num_ken)+1);
    end
    
    //tambahan
    //cari sesuai
    maks=max(typedtemp2);
    buang=[];
    diffe=sptemp2;
    for i=1:maks
        f=find(typedtemp2==i);
        diff2=diffe(f);
        capacity2=capacity(f);
        caribuang=cariBuang(capacity2,ptawal(i),diff2);
        fx=f;
        fx(caribuang')=[];
        temppt=ptawal(i);
        for j=1:length(fx)
            if j==length(fx) then
                pttemp2(fx(j))=temppt;
            else
                pttemp2(fx(j))=capacity(fx(j));
                temppt=temppt-capacity(fx(j));
            end
        end
        buang=[buang;f(caribuang')];
        
    end
    //menampilkan hasil   
    jadwal1=zeros(nd,3);
    
    //jadwal berangkat
    for i=1:nd
        [jadwal1(i,1),jadwal1(i,2),jadwal1(i,3)]=int2date(jadwaltemp2(i),start);
    end

    
    //jadwal tiba int2date
    jadwal2=zeros(nd,3);
    for i=1:nd
        [jadwal2(i,1),jadwal2(i,2),jadwal2(i,3)]=int2date(kedatangantemp2(i),start);
    end
    
    
    //jadwal permintaan
    jadwal3=zeros(nd,3);
    for i=1:nd
        [jadwal3(i,1),jadwal3(i,2),jadwal3(i,3)]=int2date(ttemp2(i),start);
    end
    //jadwal date2str
    jadwalberangkat=[];
    jadwaltiba=[];
    jadwalpermintaan=[];
    for i=1:nd
        jadwalberangkat=[jadwalberangkat;date2str(jadwal1(i,1),jadwal1(i,2),jadwal1(i,3))];
        jadwaltiba=[jadwaltiba;date2str(jadwal2(i,1),jadwal2(i,2),jadwal2(i,3))];
        jadwalpermintaan=[jadwalpermintaan;date2str(jadwal3(i,1),jadwal3(i,2),jadwal3(i,3))];
    end
    
    //tipe, kapasitas, dan yang diangkut
//    types=zeros(nd,1);
//    capacity=zeros(nd,1);
//    for i=1:nd
//        types(i)=kendaraan(modulo(i-1,num_ken)+1);
//        capacity(i)=kap(modulo(i-1,num_ken)+1);
//    end

    demandbrought=pttemp2;
    types=string(types);
    capacity=string(capacity);
    demandbrought=string(demandbrought);
    //tambahan
    number=[1:nd-length(buang)]';
    
    number=string(number);
    typedtemp2=string(typedtemp2);
    sptemp2=string(sptemp2)+' days';

    //simpan informasi
    //tambahan
    types(buang)=[];
    capacity(buang)=[];
    demandbrought(buang)=[];
    typedtemp2(buang)=[];
    jadwalberangkat(buang)=[];
    jadwaltiba(buang)=[];
    jadwalpermintaan(buang)=[];
    sptemp2(buang,:)=[];
    
    
    data=[['No.','Types Of Tankers','Capacity (unit)','Demand Brought (unit)','Types of Demand','Departure','Arrival','Date Of Demand','difference'];[number,types,capacity,demandbrought,typedtemp2,jadwalberangkat,jadwaltiba,jadwalpermintaan,sptemp2]];
    
    
    //menampilkan
    f = gcf();
    f.position=[10,10,1100,400] 
    clf
    as = f.axes_size;  // [width height]
    ut=3;
    ut = uicontrol("style","table",..
                   "string",data,..
                   "position",[5 as(2)-400 800 387],.. // => @top left corner of figure
                   "tooltipstring","Data from majors towns")
    delete(ut);
    ut = uicontrol("style","table",..
                   "string",data,..
                   "position",[5 as(2)-400 1050 387],.. // => @top left corner of figure
                   "tooltipstring","Data from majors towns")
                   
                   
    
endfunction
