function [X] = maxplussys(A,x0,q) 
X=[];

[%nargout,%nargin] = argn(0);
mode(0);

ieee(1);

if isempty(A) then
  error("maxplussys: empty input value");
end;
sizea = size(A);
if sizea(1)~=sizea(2) then
  error("maxplussys: inconsistent matrix size!");
end;
sizex = size(x0);
if sizea(1)~=sizex(1) then
  error("maxplussys: inconsistent matrix and initial vector sizes!");
end;
if sizex(2)~=1 then
  error("maxplussys: initial vector must be a column vector!");
end;

z(1:length(x0),1) = x0;
for i = 1:q
  z(:,i+1) = maxplusotimes(A,z(:,i));
end;
 X = z(:,:);

endfunction
