function supplychainschedule
    jwb=['5';'2';'2'];
    jwb = x_mdialog('enter input ',... 
          ['time for arrival tanker from TBBM (source) to other TBBM (destination)';'time for arrival tanker from TBBM (destination) to Tuban (source)';'number of tanker'],jwb);
          if jwb==[] then
              return;
          end
    tt=evstr(jwb(1));
    tr=evstr(jwb(2));
    n=evstr(jwb(3));
    e=-%inf;
    //pendefinisian A0,A1,B0,C
    A0=[e,e;tt,e];
    A1=[e,tr;e,e];
    B0=[0;e];
    C=[e,0];
    //menghitung A0 star
    A0star=maxplusstar(A0);
    
    //menentukan matriks A dan B
    A=maxplusotimes(A0star,A1);
    B=maxplusotimes(A0star,B0);

    toolbox_dir = "SCI/contrib/";
    toolbox_dir2=dir("SCI/contrib");
    name=toolbox_dir2.name;
    dates=toolbox_dir2.date;
    [datesa,datesb]=gsort(dates);
    name=name(datesb);
    sizename=size(name,1);
    hit=0;
    for i=1:sizename
        if length(name(i))>=8 then
            sementara=strsplit(name(i),7);
            sementara=sementara(1);
            if sementara=='MAXPLUS' then
                hit=i;
                break;
            end
        end    
    end
    if hit~=0 then
        toolbox_dir=toolbox_dir+name(hit)+'/modules/';
    end
    //disp(toolbox_dir);
    //input tanggal permintaan melalui file xls
    jwb = uigetfile('*.xls',toolbox_dir,Title='Choose xls for date of demand');
    if jwb == ''
      disp('You exit from this process');
      return;
    end
    
    //membaca file
    Sheets = readxls(jwb);
    
    //menentukan nilai dari tanggal permintaan
    s1=Sheets(1);
    jwb=s1.value;
    nd=size(jwb,1);
    //memilih dari hasil baca xls yang tidak NaN
    cc=[];
    for hh=1:nd
        if isnan(jwb(hh,1)) then
            cc=[cc,hh];
        end
    end
    jwb(cc,:)=[];
    nd=size(jwb,1);
    

    //String untuk kebrangkatan ke-...
    Ks=1:nd;
    Ks=Ks';
    KS=''+string(Ks)+' th '+'demand: ';
    
    //merubah bentuk tanggal ke string
    jwb1=[];
    for i=1:nd
        jwb1=[jwb1;date2str(jwb(i,1),jwb(i,2),jwb(i,3))];
    end
    jwb=jwb1;
    
    //menampilkan data dari tanggal permintaan
    jwb = x_mdialog('date of demand ',... 
          KS,jwb);
          if jwb==[] then
              return;
          end
          
    //merubah string tanggal ke tanggal
    jwb1=zeros(nd,3);
    for i=1:nd
        jwb1(i,:)=str2date(jwb(i));
    end
    start=min(jwb1(:,3))-1;
    //merubah tanggal ke integer
    Yd=zeros(nd,1);
    for i=1:nd
        Yd(i)=date2int(jwb1(i,1),jwb1(i,2),jwb1(i,3),start);
    end
    
    //mengurutkan tanggal permintaan
    for i=1:nd-1
        for j=i+1:nd
            if Yd(i)>Yd(j) then
                Yd([i,j])=Yd([j,i]);
            end
        end
    end
    
    //mendefinisikan alphamaks dan sisa yang menggunakan alphamaks
    alphamaks=ceil(nd/n);
    sisa=nd-(alphamaks-1)*n;

    //mendefinisikan H ukuran alphax1
    Htemp=maxpluszeros(1,alphamaks);
    temp=maxpluseye(2,2);
    for i=alphamaks:-1:1
        temp1=maxplusotimes(C,temp);
        temp1=maxplusotimes(temp1,B);
        Htemp(i)=temp1;
        temp=maxplusotimes(A,temp);
    end
    //tempat untuk jadwal keberangkatan
    jadwal=zeros(nd,1);
    
    //mendefinisikan H ukuran alphaxalpha dengan alpha yang maksimal
    H=maxpluszeros(alphamaks,alphamaks);
    for i=1:alphamaks
        H(i,1:alphamaks-i+1)=Htemp(i:alphamaks);
        Htemp(i)=e;
    end
    
    //menentukan jadwal
    for i=1:sisa
        btemp=Yd(i:n:(alphamaks)*n);
        l=length(btemp);
        btemptemp=btemp;
        for j=1:l
            btemp(j)=btemptemp(l-j+1);
        end
        jadwal1=maxpluslinsol(H,btemp);
        jadwal(i:n:(alphamaks)*n)=jadwal1;
    end
    //menentukan jadwal untuk alpha tidak maksimal
    if sisa<n then
        Htemp=H(1,2:alphamaks);
        H=maxpluszeros(alphamaks-1,alphamaks-1);
        //menentukan H
        for i=1:alphamaks-1
            H(i,1:alphamaks-i)=Htemp(i:alphamaks-1);
            Htemp(i)=e;
        end
        //jadwal untuk alpha tidak maksimal
        for i=sisa+1:n
            btemp=Yd(i:n:(alphamaks-1)*n);
            l=length(btemp);
            btemptemp=btemp;
            for j=1:l
                btemp(j)=btemptemp(l-j+1);
            end
            jadwal1=maxpluslinsol(H,btemp);
            jadwal(i:n:(alphamaks-1)*n)=jadwal1;
        end
    end
    
    //jadwal tiba
    jadwaltiba=tt*ones(nd,1)+jadwal;
    //selisih kedatangan dan permintaan
    selisih=Yd-jadwaltiba;
    selisih=string(selisih)+' days';
    //jadwal berangkat int2date
    jadwal1=zeros(nd,3);
    for i=1:nd
        [jadwal1(i,1),jadwal1(i,2),jadwal1(i,3)]=int2date(jadwal(i),start);
    end

    
    //jadwal tiba int2date
    jadwal2=zeros(nd,3);
    for i=1:nd
        [jadwal2(i,1),jadwal2(i,2),jadwal2(i,3)]=int2date(jadwaltiba(i),start);
    end
    
    //tanggal permintaan
    jadwal3=zeros(nd,3);
    for i=1:nd
        [jadwal3(i,1),jadwal3(i,2),jadwal3(i,3)]=int2date(Yd(i),start);
    end
    
    //jadwal date2str
    jadwalberangkat=[];
    jadwaltiba=[];
    jadwalpermintaan=[];
    for i=1:nd
        jadwalberangkat=[jadwalberangkat;date2str(jadwal1(i,1),jadwal1(i,2),jadwal1(i,3))];
        jadwaltiba=[jadwaltiba;date2str(jadwal2(i,1),jadwal2(i,2),jadwal2(i,3))];
        jadwalpermintaan=[jadwalpermintaan;date2str(jadwal3(i,1),jadwal3(i,2),jadwal3(i,3))];
    end
    
    
    
    //menampilkan jadwal keberangkatan   

    number=[1:nd]';
    number=string(number);
    data=[['No.','Departure','Arrival','Date Of Demand','Difference'];[number,jadwalberangkat,jadwaltiba,jadwalpermintaan,selisih]];
    
    f = gcf();
    f.position=[10,10,900,400] 
    clf
    as = f.axes_size;  // [width height]
    ut = uicontrol("style","table",..
                   "string",data,..
                   "position",[5 as(2)-300 800 287],.. // => @top left corner of figure
                   "tooltipstring","Data from majors towns")
    delete(ut);
    ut = uicontrol("style","table",..
                   "string",data,..
                   "position",[5 as(2)-300 800 287],.. // => @top left corner of figure
                   "tooltipstring","Data from majors towns")
                   
endfunction
